import java.io.*;
import java.security.*;

/**
 * Compute the message digest of a file
 *
 * @author Simon Parsons
 *
 * Taken from Knudsen, "Java Cryptography", page 6. Uses Knudsen's
 * Base64 handler. 
 */
public class Masher{
    public static void main(String[] args) throws Exception{
	// Check we have a file to work with.
	if (args.length != 1){
	    System.out.println("Usage: Masher <filename>");
	    return;
	}
    
	// Get a message digest object. This does all the 
	// hard work for us.
	MessageDigest md = MessageDigest.getInstance("MD5");
	
	// Calculate the digest for the input, reading it in
	// KB chunks.
	FileInputStream in = new FileInputStream(args[0]);
	byte[] buffer = new byte[8192];
	int length = in.read(buffer);
	while(length != -1){
	    md.update(buffer, 0, length);
	    length = in.read(buffer);
	}
	
	length = md.getDigestLength();
	byte[] raw = new byte[length];
	raw = md.digest();
	
	// Print out the digest
	Base64 encoder = new Base64();
	String base64 = encoder.encode(raw);
	System.out.println(base64);
    }
}
